
include topaz.e

 -- for our first trick, we will implement threads which will
 -- compute several equations, and display the results...

 -- create new instruction, tSQRT

without warning
procedure topaz_sqrt (sequence Params)

   push_stack (sqrt (pop_stack ()))

end procedure
with warning

constant tSQRT  = add_instruction (routine_id ("topaz_sqrt"))

 -- create the scripts for the threads

constant COMP_SCRIPT1 =
    -- computes the result of: floor((5*(3-1))/9) + sqrt(16/((2-0)*2))
    -- (the answer should be 3)
   {{tPUSHD, 9, 1, 3},
    {tSUB},
    {tPUSHD, 5},
    {tMUL},
    {tDIV},
    {tFLOOR},
    {tPUSHD, 0, 2},
    {tSUB},
    {tPUSHD, 2},
    {tMUL},
    {tPUSHD, 16},
    {tDIV},
    {tSQRT},
    {tADD},
    {tDISP},
    {tEND}}

constant COMP_SCRIPT2 =
    -- computes the result of sqrt (sqrt (sqrt (floor (8655/33.8))))
    -- (answer should be 2)
   {{tPUSHD, 33.8, 8655},
    {tDIV},
    {tFLOOR},
    {tSQRT},
    {tSQRT},
    {tSQRT},
    {tDISP},
    {tEND}}

constant COMP_SCRIPT3 =
    -- adds 9 to 99 one hundred times (answer should be 999)
   {{tPUSHD, 99, 0},
    {tPOP, 1},
    {tPUSHD, 9},
    {tADD},
    {tPUSHA, 1},
    {tPUSHD, 1},
    {tADD},
    {tCOPY},
    {tPUSHD, 100},
    {tEQ},
    {tIF, {tINCIP, 2}},
    {tINCIP, -10},
    {tPOP, 0},
    {tDISP},
    {tEND}}

 -- create the new threads for the scripts (equal priorities)

integer TID
TID = new_thread (0, 1, COMP_SCRIPT1)
TID = new_thread (0, 1, COMP_SCRIPT2)
TID = new_thread (1, 1, COMP_SCRIPT3)

 -- execute the instructions until the threads are finished

while (get_num_threads () > 0) do
   topaz_step ()
end while

 -- repeat, but give the slower thread a far higher priority

TID = new_thread (0, 2000, COMP_SCRIPT1)
TID = new_thread (0, 2000, COMP_SCRIPT2)
TID = new_thread (1, 3, COMP_SCRIPT3)

while (get_num_threads () > 0) do
   topaz_step ()
end while

